import os
import numpy as np

from .data_set import DataSet

def load_data(cache, is_train, dataset_name, dataset_path, resolution, pid_num, pid_shuffle, view_angles):
    if dataset_name == 'CASIA-B':
        seqs_dir = list()
        seqs_view, seqs_type, seqs_label = list(), list(), list()
        pid_fname = 'list/label_{}_{}_{}_{}.npy'.format(dataset_name, pid_num, pid_shuffle, view_angles)
        if not os.path.exists(pid_fname):
            # In CASIA-B, we ignore #5 in training (dirty data).
            pid_list = [_label for _label in sorted(list(os.listdir(dataset_path))) if _label != '005']
            if pid_shuffle: np.random.shuffle(pid_list)
            pid_list = [pid_list[:pid_num], pid_list[pid_num:]]
            np.save(pid_fname, pid_list)
        pid_list = np.load(pid_fname, allow_pickle=True)
        if is_train:
            list_ids = pid_list[0]
            for _label in list_ids:
                path_label = os.path.join(dataset_path, _label)
                for _type in sorted(list(os.listdir(path_label))):
                    path_type = os.path.join(path_label, _type)
                    for _view in sorted(list(os.listdir(path_type))):
                        if _view in view_angles:
                            _seqs_dir = os.path.join(path_type, _view)
                            seqs = os.listdir(_seqs_dir)
                            if len(seqs) > 0:
                                seqs_dir.append([_seqs_dir])
                                seqs_label.append(_label)
                                seqs_type.append(_type)
                                seqs_view.append(_view)
        else:
            list_ids = pid_list[1]
            for _label in list_ids:
                path_label = os.path.join(dataset_path, _label)
                for _type in sorted(list(os.listdir(path_label))):
                    path_type = os.path.join(path_label, _type)
                    for _view in sorted(list(os.listdir(path_type))):
                        if _view in view_angles:
                            _seqs_dir = os.path.join(path_type, _view)
                            seqs = os.listdir(_seqs_dir)
                            if len(seqs) > 0:
                                seqs_dir.append([_seqs_dir])
                                seqs_label.append(_label)
                                seqs_type.append(_type)
                                seqs_view.append(_view)            
        data_source = DataSet(seqs_dir, seqs_label, seqs_type, seqs_view, cache, resolution)
    return data_source

