import os
import numpy as np

from .data_set import DataSet

def load_data(cache, is_train, dataset_name, dataset_path, resolution):
    if dataset_name == 'Treadmill-B':
        pid_fname = 'list/label_{}.npy'.format(dataset_name)
        if not os.path.exists(pid_fname):
            pid_list = [_label for _label in sorted(list(os.listdir(dataset_path)))]
            np.save(pid_fname, pid_list)
        pid_list = np.load(pid_fname)
        list_ids = pid_list
        if is_train:
            seqs_dir, seqs_view, seqs_type, seqs_label = list(), list(), list(), list()
            for _label in list_ids:
                path_label = os.path.join(dataset_path, _label)
                for _type in sorted(list(os.listdir(path_label))):
                    path_type = os.path.join(path_label, _type)
                    for _view in sorted(list(os.listdir(path_type))):
                        if _view == 'Train':
                            _seqs_dir = os.path.join(path_type, _view)
                            seqs = os.listdir(_seqs_dir)
                            if len(seqs) > 0:
                                #print('train {}'.format(_seqs_dir))
                                seqs_dir.append([_seqs_dir])
                                seqs_label.append(_label)
                                seqs_type.append(_type)
                                seqs_view.append(_view)
            data_source = DataSet(seqs_dir, seqs_label, seqs_type, seqs_view, cache, resolution)
        else:
            gallery_dir, gallery_view, gallery_type, gallery_label = list(), list(), list(), list()
            probe_dir, probe_view, probe_type, probe_label = list(), list(), list(), list()
            for _label in list_ids:
                path_label = os.path.join(dataset_path, _label)
                for _type in sorted(list(os.listdir(path_label))):
                    path_type = os.path.join(path_label, _type)
                    for _view in sorted(list(os.listdir(path_type))):
                        _seqs_dir = os.path.join(path_type, _view)
                        seqs = os.listdir(_seqs_dir)
                        if len(seqs) > 0:
                            if _view == 'Train':
                                #print('gallery {}'.format(_seqs_dir))
                                gallery_dir.append([_seqs_dir])
                                gallery_label.append(_label)
                                gallery_type.append(_type)
                                gallery_view.append(_view)
                            else:
                                #print('probe {}'.format(_seqs_dir))
                                probe_dir.append([_seqs_dir])
                                probe_label.append(_label)
                                probe_type.append(_type)
                                probe_view.append(_view)
            gallery_source = DataSet(gallery_dir, gallery_label, gallery_type, gallery_view, cache, resolution)
            probe_source = DataSet(probe_dir, probe_label, probe_type, probe_view, cache, resolution)
            data_source = [gallery_source, probe_source]
    return data_source

